package com.syc.slm.slmbi.dto;

import com.syc.slm.slmbi.enums.AccessType;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.List;

/**
 * slm-bi
 * 仪表板权限
 *
 * @author : lin
 * @date : 2021-03-25 19:05
 **/
@Data
@ApiModel(value = "仪表板权限DTO", description = "仪表板权限DTO")
@EqualsAndHashCode(callSuper = false)
public class InstrumentPanelPermissionDTO {
    @ApiModelProperty(value = "主键id")
    private String id;

    @ApiModelProperty(value = "访问权限类型", required = true)
    private String accessType;

    @ApiModelProperty(value = "描述")
    private String description;

    @ApiModelProperty(value = "自定义权限配置，当访问类型为CUSTOM时必填")
    private List<CustomPermissionDTO> customPermissions;

}
