package com.syc.slm.slmbi.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.syc.slm.slmbi.dto.InstrumentPanelConfigDTO;
import com.syc.slm.slmbi.entity.InstrumentPanelConfig;
import com.syc.slm.slmbi.vo.InstrumentPanelConfigVo;

import javax.validation.constraints.NotNull;

/**
 * slm-bi
 * 仪表板配置
 *
 * @author : lin
 * @date : 2021-03-25 15:10
 **/
public interface InstrumentPanelConfigService extends IService<InstrumentPanelConfig>{


    /**
     * 根据仪表板id获取对应已发布配置
     * @param instrumentPanelId
     * @return
     */
    InstrumentPanelConfigVo getPublishConfigByPanelId(@NotNull String instrumentPanelId);

    /**
     * 根据仪表板id获取对应配置
     * @param instrumentPanelId
     * @return
     */
    InstrumentPanelConfigVo getConfigByPanelId(@NotNull String instrumentPanelId);
    /**
     * 保存发布仪表板配置
     * @param config
     * @return
     */
    String publish(InstrumentPanelConfigDTO config);
    /**
     * 保存仪表板配置
     * @param config
     * @return
     */
    String saveConfig(InstrumentPanelConfigDTO config);

    /**
     * 根据仪表板id删除仪表板配置
     * @param panelId
     */
    void delConfig(@NotNull String panelId);
}
