package com.syc.slm.slmbi.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.syc.slm.slmbi.dto.InstrumentPanelPermissionDTO;
import com.syc.slm.slmbi.entity.InstrumentPanelPermission;
import com.syc.slm.slmbi.vo.CustomPermissionVo;
import com.syc.slm.slmbi.vo.InstrumentPanelPermissionVo;
import lombok.NonNull;

import java.util.List;
/**
 * slm-bi
 * 仪表板权限控制
 *
 * @author : lin
 * @date : 2021-03-25 18:54
 **/
public interface InstrumentPanelPermissionService extends IService<InstrumentPanelPermission> {
    /**
     * 保存仪表板权限
     *
     * @param permissions
     * @return
     */
    String savePermission(InstrumentPanelPermissionDTO permissions);

    /**
     * 从其他仪表板复制配置
     *
     * @param instrumentPanelId
     * @return
     */
    List<InstrumentPanelPermissionVo> saveCopyOtherPermission(@NonNull String instrumentPanelId);

    /**
     * 将仪表板权限复制给其他仪表板
     *
     * @param permissions
     * @param otherInstrumentPanelId
     * @return
     */
    String saveCopyToOtherPermission(InstrumentPanelPermissionDTO permissions, String otherInstrumentPanelId);

    /**
     * 根据仪表板id获取仪表板权限
     *
     * @param instrumentPanelId
     * @return
     */
    List<InstrumentPanelPermissionVo> selectPermissionByPanelId(@NonNull String instrumentPanelId);

    /**
     * 根据仪表板id删除仪表板权限
     * @param panelId
     */
    void delPermissionByPanelId(@NonNull String panelId);

    /**
     * 根据仪表板id获取已经发布的配置
     * @param panelId
     * @return
     */
    List<CustomPermissionVo> getPublishPermissionByPanelId(@NonNull String panelId);
}
