package com.syc.slm.slmbi.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.syc.slm.common.core.constant.SlmConstants;
import com.syc.slm.slmbi.dao.InstrumentPanelConfigMapper;
import com.syc.slm.slmbi.dto.InstrumentPanelConfigDTO;
import com.syc.slm.slmbi.entity.BaseEntity;
import com.syc.slm.slmbi.entity.InstrumentPanelConfig;
import com.syc.slm.slmbi.entity.InstrumentPanelDraft;
import com.syc.slm.slmbi.enums.PublishedStatus;
import com.syc.slm.slmbi.service.InstrumentPanelConfigService;
import com.syc.slm.slmbi.service.InstrumentPanelPermissionService;
import com.syc.slm.slmbi.vo.InstrumentPanelConfigVo;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.validation.constraints.NotNull;
import java.util.List;

/**
 * slm-bi
 * 仪表板数据以及样式配置
 *
 * @author : lin
 * @date : 2021-03-25 19:11
 **/
@Service
public class InstrumentPanelConfigServiceImpl extends ServiceImpl<InstrumentPanelConfigMapper, InstrumentPanelConfig> implements InstrumentPanelConfigService {

    @Autowired
    private InstrumentPanelPermissionService permissionService;
    @Override
    @Transactional(readOnly = true)
    public InstrumentPanelConfigVo getPublishConfigByPanelId(@NotNull String instrumentPanelId) {
        LambdaQueryWrapper<InstrumentPanelConfig> where = new LambdaQueryWrapper<>();
        where.eq(BaseEntity::getRecordStatus, SlmConstants.DATA_VALID);
        where.eq(InstrumentPanelConfig::getPanelId, instrumentPanelId);
        where.eq(InstrumentPanelConfig::getPublished, PublishedStatus.PUBLISHED);
        InstrumentPanelConfig config = baseMapper.selectOne(where);
        InstrumentPanelConfigVo vo = new InstrumentPanelConfigVo();
        BeanUtils.copyProperties(config,vo);
        vo.setPermissions(permissionService.getPublishPermissionByPanelId(instrumentPanelId));
        return vo;
    }

    @Override
    public InstrumentPanelConfigVo getConfigByPanelId(String instrumentPanelId) {
        return null;
    }

    @Override
    public String publish(InstrumentPanelConfigDTO config) {
        return null;
    }

    @Override
    public String saveConfig(InstrumentPanelConfigDTO config) {
        return null;
    }

    @Override
    public void delConfig(@NotNull String panelId) {
        LambdaQueryWrapper<InstrumentPanelConfig> where = new LambdaQueryWrapper<>();
        where.eq(InstrumentPanelConfig::getRecordStatus, SlmConstants.DATA_VALID);
        where.eq(InstrumentPanelConfig::getPanelId,panelId);
        List<InstrumentPanelConfig> configs = baseMapper.selectList(where);
        if(CollectionUtils.isNotEmpty(configs)){
            configs.forEach(x->{
                x.setRecordStatus(SlmConstants.DATA_DELETED);
                baseMapper.updateById(x);
            });
        }
    }
}
