package com.syc.slm.slmbi.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.google.gson.reflect.TypeToken;
import com.syc.slm.common.core.constant.SlmConstants;
import com.syc.slm.slmbi.dao.InstrumentPanelPermissionMapper;
import com.syc.slm.slmbi.dto.InstrumentPanelPermissionDTO;
import com.syc.slm.slmbi.entity.InstrumentPanelPermission;
import com.syc.slm.slmbi.enums.PublishedStatus;
import com.syc.slm.slmbi.service.InstrumentPanelPermissionService;
import com.syc.slm.slmbi.vo.CustomPermissionVo;
import com.syc.slm.slmbi.vo.InstrumentPanelPermissionVo;
import lombok.NonNull;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * slm-bi
 * 仪表板权限
 *
 * @author : lin
 * @date : 2021-03-25 19:04
 **/
@Service
public class InstrumentPanelPermissionImpl
    extends ServiceImpl<InstrumentPanelPermissionMapper, InstrumentPanelPermission>
    implements InstrumentPanelPermissionService {
    @Override
    public String savePermission(InstrumentPanelPermissionDTO permissions) {
        //判断仪表板的名称是否重复
        //删除原本的权限
        //插入现有的权限
        //更新仪表板的名称跟分组
        return null;
    }

    @Override
    public List<InstrumentPanelPermissionVo> saveCopyOtherPermission(@NonNull String instrumentPanelId) {
        return null;
    }

    @Override
    public String saveCopyToOtherPermission(InstrumentPanelPermissionDTO permissions, String otherInstrumentPanelId) {
        return null;
    }

    @Override
    public List<InstrumentPanelPermissionVo> selectPermissionByPanelId(@NonNull String instrumentPanelId) {
        return null;
    }

    @Override
    public void delPermissionByPanelId(@NonNull String panelId) {
        LambdaQueryWrapper<InstrumentPanelPermission> where = new LambdaQueryWrapper<>();
        where.eq(InstrumentPanelPermission::getPanelId, panelId);
        where.eq(InstrumentPanelPermission::getRecordStatus, SlmConstants.DATA_VALID);
        List<InstrumentPanelPermission> permissions = baseMapper.selectList(where);
        if (CollectionUtils.isNotEmpty(permissions)) {
            permissions.forEach(x -> {
                x.setRecordStatus(SlmConstants.DATA_DELETED);
                baseMapper.updateById(x);
            });
        }
    }

    @Override
    @Transactional(readOnly = true)
    public List<CustomPermissionVo> getPublishPermissionByPanelId(@NonNull String panelId) {
        LambdaQueryWrapper<InstrumentPanelPermission> where = new LambdaQueryWrapper<>();
        where.eq(InstrumentPanelPermission::getPanelId, panelId);
        where.eq(InstrumentPanelPermission::getRecordStatus, SlmConstants.DATA_VALID);
        where.eq(InstrumentPanelPermission::getPublished, PublishedStatus.PUBLISHED);
        List<InstrumentPanelPermission> permissions = baseMapper.selectList(where);
        return CollectionUtils.isNotEmpty(permissions) ?
            SlmConstants.gson.fromJson(SlmConstants.gson.toJson(permissions),
                                       new TypeToken<List<CustomPermissionVo>>() {
                                       }.getType()) : null;
    }
}
