package com.syc.slm.slmbi.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.syc.slm.common.core.constant.SlmConstants;
import com.syc.slm.slmbi.dao.InstrumentPanelTreeMapper;
import com.syc.slm.slmbi.entity.BaseEntity;
import com.syc.slm.slmbi.entity.InstrumentPanelTree;
import com.syc.slm.slmbi.service.InstrumentPanelTreeService;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Set;

/**
 * 仪表板树聚合表
 *
 * @author lin
 * @date 2021-04-01 10:52:44
 */
@Service
public class InstrumentPanelTreeServiceImpl extends ServiceImpl<InstrumentPanelTreeMapper, InstrumentPanelTree>
    implements InstrumentPanelTreeService {

    @Override
    public void batchUpdateTreeByIds(Set<String> treeIds, Integer recordStatus) {
        if(CollectionUtils.isNotEmpty(treeIds)){
            baseMapper.batchUpdateTreeByIds(treeIds,recordStatus);
        }
    }

    @Override
    public void initTree(String nodeId, String nodeType, String bizId, String bizName) {
        InstrumentPanelTree panelTree = baseMapper.selectById(nodeId);
        InstrumentPanelTree tree = new InstrumentPanelTree();
        tree.setId(bizId);
        tree.setNodeType(nodeType);
        tree.setFullName(panelTree.getFullName() + "." + bizName);
        tree.setFullId(panelTree.getFullId() + "." + bizId);
        baseMapper.insert(tree);
    }

    @Override
    public void delTreeByPanelId(String panelId) {
        InstrumentPanelTree tree = baseMapper.selectById(panelId);
        tree.setRecordStatus(SlmConstants.DATA_DELETED);
        baseMapper.updateById(tree);
        //#todo 仪表板组件树
        LambdaQueryWrapper<InstrumentPanelTree> where = new LambdaQueryWrapper<>();
        where.eq(BaseEntity::getRecordStatus, SlmConstants.DATA_VALID);
        where.likeRight(InstrumentPanelTree::getFullId,tree.getFullId()+".");
        List<InstrumentPanelTree> list = baseMapper.selectList(where);
        if(CollectionUtils.isNotEmpty(list)){
            list.forEach(x->{
                x.setRecordStatus(SlmConstants.DATA_DELETED);
                baseMapper.updateById(x);
            });
        }
    }
}
